from ..utils.error import errorInvalidAccessToken
from ..utils.microservices import Microservice
from ..utils.request import Request, GET


class WorkspaceGateway:

    @classmethod
    def getUser(cls, accessToken, headers, language):
        response = Request.fetch(
            url="{}/workspace/access-token/{}".format(Microservice.getBaseUrl(Microservice.workspace), accessToken),
            method=GET,
            headers=headers,
            deadline=50
        )

        if response.status == 400:
            return None, response.contentJson()
        elif response.status > 200:
            return None, errorInvalidAccessToken(language=language)

        return response.contentJson()["user"], None
