from .error import ErrorModel


class ApiResponse:

    def __init__(self, language, messages):
        self.messages = messages
        self.language = language

    def error(self, code, messageKey, **data):
        message = self.messages.get(key=messageKey, language=self.language, **data)
        return ErrorModel.new(code=code, message=message)

    def errors(self, code, messageKey, errors, **data):
        message = self.messages.get(key=messageKey, language=self.language, **data)
        return ErrorModel.array(message=message, code=code, elements=errors)

    def errorElement(self, code, messageKey, **data):
        message = self.messages.get(key=messageKey, language=self.language, **data)
        return ErrorModel.element(message=message, code=code)

    def success(self, messageKey, **data):
        return {
            "message": self.messages.get(key=messageKey, language=self.language, **data)
        }