

class CsvParser:

    def __init__(self, text):
        self.text = text.strip()
        self.rows = self.text.splitlines()
        self.delimiter = "," if "sep=" not in self.rows[0] else self.rows[0][4]
        if "sep=" in self.rows[0]:
            self.rows.pop(0)

    def headers(self):
        return self.rows[0].split(self.delimiter)

    def dict(self):
        result = []
        for row in self.rows[1:]:
            arrayOfValues = CsvParser.mergeQuotes(array=row.split(self.delimiter))
            result.append({header: value for (header, value) in zip(self.headers(), arrayOfValues)})
        return result

    @classmethod
    def mergeQuotes(cls, array, delimiter=","):
        start = -1
        content = []
        for index, string in enumerate(array):
            if string and string[0] == "\"":
                start = index
                content.append(string[1:].strip())
            if content and "\"" not in string:
                array[index] = None
                content.append(string.strip())
            if string and string[-1] == "\"":
                array[index] = None
                content.append(string[:len(string) - 1].strip())
                array[start] = delimiter.join(content)
                content = []
        return [string for string in array if string is not None]