from pytz import utc, timezone


class Date:

    @classmethod
    def toUTC(cls, date):
        return utc.localize(date).isoformat()

    @classmethod
    def getInTimezone(cls, datetime, zone="America/Sao_Paulo"):
        tz = timezone(zone)
        return tz.normalize(tz.localize(datetime))

    @classmethod
    def getInUtc(cls, datetime, zone="America/Sao_Paulo"):
        return cls.getInTimezone(datetime, zone).astimezone(utc).replace(tzinfo=None)